{$G+}
{$M 16384,0,655360}
unit graxmsc;
interface
uses dos{,data};
type typobjekt=record
     obsazen:boolean;
     aktivovan:boolean;
     enemy:boolean;   {u strel se pouziva jako indikator od koho je}
     typpohybu:byte;
     opakovani:byte;
     strety:byte;
     cyklymezivystrely,dodalsihovystrelu:byte;
     cisloanimace:byte;
     pozicevtabulce:byte;{v tabulce pohybu}
     samo_ovladany,zobrazen,aktivovany:boolean;
     nastav_zobrazeni: boolean;
     sirkax,sirkay:byte;
     stity:shortint;
     delta_x,delta_y:shortint;
     offsetovaadresa,lhrohx,lhrohy: integer;     {roh 0...}
     poleobjektu:pointer;

     end;
var
  pohyby:array[1..20,1..20,0..2] of byte;
procedure set320x200mode;
procedure set320x240mode;
procedure wait;
procedure pixel(x,y:integer;barva:byte;videoshift:word;delkaradky:byte);
procedure ctipixel(x,y:integer;var barva:byte;videoshift:word;delkaradky:byte);
function takt:boolean;
procedure zobrazobjekt(var objp:typobjekt;cislocasti:byte);
procedure posunpalety (var objp:typobjekt;zmena_barvy:byte);
procedure posunanimpalety (anpole:pointer;zmena_barvy:byte);
procedure pozadi(souy,offposun,handxms:word;po:pointer);
implementation
var {pole1:poiobr1;}
  adresa:array[1..4,1..2] of word;
  promtakt:boolean;
  oldintcasovac:procedure;
  aktualniradka,pozicevradce,pozicey:word;

function takt:boolean;
     begin
     if promtakt then takt:=true;
     promtakt:=false;
     end;

procedure Wait; assembler;
asm
{    cli}
    mov dx,3DAh
@l1:
    in al,dx
    and al,08h
    jnz @l1

@l2:
    in al,dx
    and al,08h
    jz  @l2
  {  sti}
end;
procedure set320x240mode;
const SC_INDEX = $03c4;
CRTC_INDEX = $03d4;
MISC_OUTPUT= $03c2 ;
SCREEN_SEG= $0a000  ;


CRTParams: array[0..9]of word =(
   $00d06,$03e07,$04109,$0ea10,$0ac11,$0df12,$00014,$0e715,$00616,$0e317);

CRT_PARAM_LENGHT =10;
begin
asm
          push bp
          push si
          push di

          mov ax,13h
          int 10h

          mov dx,SC_INDEX
          mov ax,0604h
          out dx,ax
          mov ax,0100h
          out dx,ax
          mov dx,MISC_OUTPUT
          mov al,0e3h
          out dx,al
          mov dx,SC_INDEX
          mov ax,0300h
          out dx,ax

          mov dx,CRTC_INDEX
          mov al,11h
          out dx,al
          inc dx
          in al,dx
          and al,7fh
          out dx,al
          dec dx
          cld
          mov si,offset CRTParams
          mov cx,CRT_PARAM_LENGHT
@CRTloop:  lodsw
          out dx,ax
          loop @CRTloop

          mov dx,SC_INDEX
          mov ax,0f02h
          out dx,ax
          mov ax,SCREEN_SEG
          mov es,ax
          sub di,di
          sub ax,ax
          mov cx,8000h
          rep stosw

          pop di
          pop si
          pop bp
end;
end;

procedure set320x200mode;
begin
asm
mov ax,13h
int 10h
mov dx,3ceh
mov al,5
out dx,al
inc dx
in  al,dx
and al,11101111b
out dx,al
dec dx
mov al,6
out dx,al
inc dx
in  al,dx
and al,11111101b
out dx,al
mov dx,3c4h
mov al,4
out dx,al
inc dx
in al,dx
and al,11110111b
or al,4
out dx,al
mov ax,0a000h
mov es,ax
xor di,di
mov ax,di
mov cx,8000h
rep stosw
mov dx,3d4h
mov al,14h
out dx,al
inc dx
in  al,dx
and al,10111111b
out dx,al
dec dx
mov al,17h
out dx,al
inc dx
in  al,dx
or  al,01000000b
out dx,al
end;
end;
procedure pixel(x,y:integer;barva:byte;videoshift:word;delkaradky:byte);
var rovina,mapmask,x2:byte;
begin
x2:=x div 4;
rovina:=x mod 4;
mapmask:=1 shl rovina;
port[$3c4]:=2;
port[$3c5]:=mapmask;
mem[$a000:delkaradky*y+x2+videoshift]:=barva;
end;


procedure ctipixel(x,y:integer;var barva:byte;videoshift:word;delkaradky:byte);
var bbb,by,rovina,mapmask,x2,bajt:byte;
w1,w2,w3,w4:word;
begin
x2:=x div 4;
rovina:=x mod 4;
mapmask:= rovina;
port[$3ce]:=4;             {registr Read map select}
port[$3cf]:=mapmask;
barva:=mem[$a000:delkaradky*y+x2+videoshift];
end;


procedure zobrazobjekt(var objp:typobjekt;cislocasti:byte);
var w1,w2,memposun:word;
    dalsiradka:word;
    xmem,sirx,siry,rovina,mapmask:byte;

begin
with objp do begin
offsetovaadresa:=32000*cislocasti;
w1:=seg(poleobjektu^);
w2:=ofs(poleobjektu^);

xmem:=lhrohx div 4;
rovina:=lhrohx mod 4;

memposun:=lhrohy*80+offsetovaadresa+xmem;
end;
asm

push ds

mov ds,w1
mov si,w2
mov ax,0a000h
mov es,ax
mov di,memposun


mov ch,1        {do ch rotujici mapmask (2x)}
mov cl,rovina
shl ch,cl
mov cl,ch
shl ch,4
add ch,cl

mov bx,di
mov cl,4
@rov:
 mov dx,03c4h
 mov al,2
 out dx,al
 mov al,ch
 inc dx
 out dx,al
 push cx
 push di







@dalsi:
  lodsw
  add di,ax
  lodsw
  cmp ax,0
  jz @dalsirov
  mov cx,ax
  rep movsb

  jmp @dalsi


@dalsirov:
pop di
pop cx
rol ch,1
   {kdyz cf pak se zobrazuje o byte dal}
adc di,0

dec cl
jnz @rov


pop ds
   end;
   end;


procedure posunpalety (var objp:typobjekt;zmena_barvy:byte);
var w1,w2,memposun:word;
    zmena:byte;
begin
with objp do begin
w1:=seg(poleobjektu^);
w2:=ofs(poleobjektu^);
zmena:=zmena_barvy;
end;
asm
  push ds
  mov ds,w1
  mov si,w2
  mov dl,4
@rov:

@dalsi:
  lodsw

  lodsw
  cmp ax,0
  jz @dalsirov
  mov cx,ax
@lop:
  mov bx,si
  mov di,bx
  lodsb
  add al,zmena
  stosb
  loop @lop
  jmp @dalsi


@dalsirov:

dec dl
jnz @rov


pop ds
   end;
   end;

procedure posunanimpalety (anpole:pointer;zmena_barvy:byte);
var w1,w2,memposun:word;
    zmena:byte;
begin
w1:=seg(anpole^);
w2:=ofs(anpole^);
zmena:=zmena_barvy;

asm
  push ds
  mov ds,w1
  mov si,w2
  mov dl,4
@rov:

@dalsi:
  lodsw

  lodsw
  cmp ax,0
  jz @dalsirov
  mov cx,ax
@lop:
  mov bx,si
  mov di,bx
  lodsb
  add al,zmena
  stosb
  loop @lop
  jmp @dalsi


@dalsirov:

dec dl
jnz @rov


pop ds
   end;
   end;


procedure pozadi(souy,offposun,handxms:word;po:pointer);
var sss,ooo,memposun,pos:word;
offsetxms,yps:longint;
  movetab:array[0..7] of word;
 kount:byte;
begin

yps:=souy;
movetab[0]:=16000;movetab[1]:=0;

movetab[2]:=handxms;
movetab[5]:=0;
movetab[6]:=offposun;movetab[7]:=$0a000;

sss:=seg(movetab);ooo:=ofs(movetab);

for kount:=0 to 3 do begin
offsetxms:=kount*640000+yps*80;

{movetab[1],[2] je delka dat}
movetab[3]:=offsetxms mod 65536;movetab[4]:=offsetxms div 65536;
asm
mov dx,03c4h
 mov al,2
 out dx,al
 mov ax,1
 mov cl,kount
 shl al,cl
 inc dx
 out dx,al


mov bx,sss
mov si,ooo
push ds
mov ds,bx
mov ah,0bh
call po
pop ds
end;

end;




end;

end.
